/*
 * ===========================================================================================
 *
 *       Filename:  hpm.S
 *
 *    Description:  pmu counter driver for optimal use.
 *
 *        Version:  Melis3.0
 *         Create:  2021-01-31 16:05:51
 *       Revision:  none
 *       Compiler:  GCC:version 7.2.1 20170904 (release),ARM/embedded-7-branch revision 255204
 *
 *         Author:  caozilong@allwinnertech.com
 *   Organization:  BU1-PSW
 *  Last Modified:  2021-02-01 08:43:23
 *
 * ===========================================================================================
 */

.option norvc
.global	hpm_get_icache_miss_rate
hpm_get_icache_miss_rate:
    li   x5, 0xffffffff
    csrw mcountinhibit, x5
    csrw mcycle, x0
    csrw minstret, x0
    csrw mhpmcounter3, x0
    csrw mhpmcounter4, x0
    csrw mhpmcounter5, x0
    csrw mhpmcounter6, x0
    csrw mhpmcounter7, x0
    csrw mhpmcounter8, x0
    csrw mhpmcounter9, x0
    csrw mhpmcounter10, x0
    csrw mhpmcounter11, x0
    csrw mhpmcounter12, x0
    csrw mhpmcounter13, x0
    csrw mhpmcounter14, x0
    csrw mhpmcounter15, x0
    csrw mhpmcounter16, x0
    csrw mhpmcounter17, x0
    csrw mhpmcounter18, x0
    csrw mhpmcounter19, x0
    csrw mhpmcounter20, x0
    csrw mhpmcounter21, x0
    csrw mhpmcounter22, x0
    csrw mhpmcounter23, x0
    csrw mhpmcounter24, x0
    csrw mhpmcounter25, x0
    csrw mhpmcounter26, x0
    csrw mhpmcounter27, x0
    csrw mhpmcounter28, x0
    csrw mhpmcounter29, x0
    csrw mhpmcounter30, x0
    csrw mhpmcounter31, x0

    li   x5, 1
    csrw mhpmevent3, x5
    li   x5, 2
    csrw mhpmevent4, x5
    li   x5, 3
    csrw mhpmevent5, x5
    li   x5, 4
    csrw mhpmevent6, x5
    li   x5, 5
    csrw mhpmevent7, x5
    li   x5, 6
    csrw mhpmevent8, x5
    li   x5, 7
    csrw mhpmevent9, x5
    li   x5, 0xb
    csrw mhpmevent13, x5
    li   x5, 0xc
    csrw mhpmevent14, x5
    li   x5, 0xd
    csrw mhpmevent15, x5
    li   x5, 0xe
    csrw mhpmevent16, x5
    li   x5, 0xf
    csrw mhpmevent17, x5

    li   x5, 0xffffffff
    csrw mcounteren, x5
    
    li   x5, 0xffffffff
    csrw scounteren, x5

    csrw mcountinhibit, x0

    ret
