/*
 * ===========================================================================================
 *
 *       Filename:  blobdata.S
 *
 *    Description:  include blob data to image.
 *
 *        Version:  Melis3.0 
 *         Create:  2019-11-21 18:03:56
 *       Revision:  none
 *       Compiler:  GCC:version 7.2.1 20170904 (release),ARM/embedded-7-branch revision 255204
 *
 *         Author:  caozilong@allwinnertech.com
 *   Organization:  BU1-PSW
 *  Last Modified:  2020-08-04 09:21:42
 *
 * ===========================================================================================
 */
#include <kconfig.h>

    .section .ramdisk
    .globl  blob_input_ramdisk_start
blob_input_ramdisk_start:
    .incbin "ekernel/arch/riscv/sunxi-fxxx/ramdisk.img"
    .globl  blob_input_ramdisk_end
blob_input_ramdisk_end: 

    .section .dtbcfgs
#ifdef CONFIG_OF
    .globl  blob_input_dtb_start
blob _input_dtb_start:
    #.incbin "workspace/suniv/ramfs/sunxi-v459.dtb"
    .globl  blob_input_dtb_end
blob_input_dtb_end: 
#endif

    .section .text.sbi
    .globl  blob_input_sbi_start
blob_input_sbi_start:
    .incbin "projects/f133-fpga-board/sbi-bin/sbi.bin"
    .globl  blob_input_sbi_end
blob_input_sbi_end:
    .end
