/*
 * ===========================================================================================
 *
 *       Filename:  platform.h
 *
 *    Description:  for C906 FreeRTOS port.
 *
 *        Version:  Melis3.0 
 *         Create:  2021-01-27 14:24:50
 *       Revision:  none
 *       Compiler:  GCC:version 7.2.1 20170904 (release),ARM/embedded-7-branch revision 255204
 *
 *         Author:  caozilong@allwinnertech.com
 *   Organization:  BU1-PSW
 *  Last Modified:  2021-01-27 15:22:53
 *
 * ===========================================================================================
 */
#ifndef _C906RISCV_PLATFORM_
#define _C906RISCV_PLATFORM_
#include <stdio.h>

#define CLINT_CTRL_ADDR   0x14000000
#define DBG(fmt, ...)     do { printf("%s line %d, "fmt, __func__, __LINE__, ##__VA_ARGS__); } while (0)

#endif
