/*
 * ===========================================================================================
 *
 *       Filename:  misa.h
 *
 *    Description:  misa definitions of rsicv.
 *
 *        Version:  Melis3.0
 *         Create:  2020-06-24 09:44:39
 *       Revision:  none
 *       Compiler:  GCC:version 7.2.1 20170904 (release),ARM/embedded-7-branch revision 255204
 *
 *         Author:  caozilong@allwinnertech.com
 *   Organization:  BU1-PSW
 *  Last Modified:  2020-06-24 10:49:06
 *
 * ===========================================================================================
 */

#ifndef __MISA_H_DEF__
#define __MISA_H_DEF__

#define RV(x) ((unsigned long)1 << (x - 'A'))
#define RVI RV('I')
#define RVE RV('E') /* E and I are mutually exclusive */
#define RVM RV('M')
#define RVA RV('A')
#define RVF RV('F')
#define RVD RV('D')
#define RVC RV('C')
#define RVS RV('S')
#define RVU RV('U')
#define RVH RV('H')

#endif
